# -*- coding: iso-8859-15 -*-
#     file     : python/t_AppExeption.py
#     author   : Marcus Rickert
#     RCS      : $Id: t_AppException.py,v 1.4 2010-01-24 20:21:28 mr Exp $
#     purpose  : class t_AppException
#
#     Copyright (C) 2005 :  Marcus Rickert

# TODO:
#

import sys

g_AppExceptions = [ ]

def printExceptionMessages():

    global g_AppExceptions
    
    v_FirstError = 1
    g_AppExceptions.reverse()
    for v_Exception in g_AppExceptions:
        if v_FirstError:
            if v_Exception.f_Filename != None:
                sys.stderr.write("ERROR: %s (file '%s')\n" % (v_Exception.f_Message, v_Exception.f_Filename))
            else:
                sys.stderr.write("ERROR: %s\n" % v_Exception.f_Message)
            v_FirstError = 0
        else:
            sys.stderr.write("  triggered by: %s\n" % v_Exception.f_Message)
        if v_Exception.f_IOError:
            sys.stderr.write("  triggered by IO-ERROR %d in file '%s': %s\n" %
                             (v_Exception.f_IOError.errno, v_Exception.f_Filename,
                              v_Exception.f_IOError.strerror))
    g_AppExceptions = []

def getInnermostExceptionMessage():

    if len(g_AppExceptions) == 0:
        return "NO ERROR"
    else:
        return g_AppExceptions[0].f_Message

class t_AppException:
    def __init__(self,
                 p_Class = None,
                 p_IOError = None,
                 p_Filename = None,
                 p_Message = None):
        self.f_Class = p_Class
        self.f_Filename = p_Filename
        self.f_IOError = p_IOError
        self.f_Message = p_Message
        g_AppExceptions.append(self)

class t_EnvException(t_AppException):
    def __init__(self,
                 p_Class = None,
                 p_Message = None):
        t_AppException.__init__(self, p_Class=p_Class, p_Message=p_Message)
